Subject: bug#61098: 29.0.60; Confusing behavior of show-paren-mode

From: Dmitry Gutov <[email-masked]>
Date: Sun, 5 Feb 2023 19:21:29 +0200

On 05/02/2023 17:24, Eli Zaretskii wrote:
>> From: Stefan Monnier<[email-masked]>
>> Cc:[email-masked],[email-masked],[email-masked]
>> Date: Sun, 05 Feb 2023 10:19:24 -0500
>>
>>> I guess I don't understand what show-paren-local-mode does, then.  Let
>>> me explain my line of reasoning:
>>>
>>>    (define-minor-mode show-paren-local-mode
>>>      "Toggle `show-paren-mode' only in this buffer."
>>>      :variable ( show-paren-mode .
>>> 		(lambda (val) (setq-local show-paren-mode val)))
>>>      (cond
>>>       ((eq show-paren-mode (default-value 'show-paren-mode))
>>>        (unless show-paren-mode
>>> 	(show-paren--delete-overlays))
>>>        (kill-local-variable 'show-paren-mode))
>>>       ((not (default-value 'show-paren-mode))
>>>        ;; Locally enabled, but globally disabled.
>>>        (show-paren-mode 1)                ; Setup the timer.
>>>        (setq-default show-paren-mode nil) ; But keep it globally disabled.
>>>        )
>>>       (t ;; Locally disabled only.
>>>        (show-paren--delete-overlays))))
>>>
>>> When I looked at the above function and stepped through it in the OP's
>>> scenario, what I saw was that the 2nd condition of 'cond' doesn't
>>> fire, because the default-value of show-paren-mode is t nowadays.  So
>>> I concluded that this code relies on the mode being globally off by
>>> default, and attempted to fix the condition that turns the mode on
>>> locally even though it is on globally.
>> But if the mode is already globally enabled, the (setq-default show-paren-mode nil)
>> will definitely not be right: you'd end up disabling it globally (while
>> maybe keeping it enabled locally).
>>
>>> The predicate used by the timer requires either a match of the buffer
>>> (which doesn't happen in this case) or that the local value of
>>> show-paren-mode is non-nil.  Setting the local value non-nil is the
>>> job of the mode function, isn't it?
>> Yes, but the first branch of the `cond` incorrectly does
>> `kill-local-variable` under the assumption that the local value doesn't
>> matter if it's the same as the global one, but that's not true here
>> because (as a wise man said):
>>
>>     The predicate used by the timer requires either a match of the buffer
>>     (which doesn't happen in this case) or that the local value of
>>     show-paren-mode is non-nil.
> This answers only half of my questions, but if you and Dmitry think
> Dmitry's patch will solve this problem, then Dmitry, please install it
> and close this bug.

Installed.

Some testing revealed a certain issue, which until now was not really a 
problem:

The first time I 'M-x show-paren-local-mode' with show-paren-mode 
enabled globally, it _turns off_ the mode locally. Which kind of makes 
sense for a lot of cases, but not when the user's intention is to 
forcibly enable it.

Evaluating (show-paren-local-mode 1) still does the intended thing, though.

Just as well as (add-hook 'some-special-mode #'show-paren-local-mode).

Toggling 'M-x show-paren-local-mdoe' twice also does that.

If we do consider this a problem, a further fix could look like this:

diff --git a/lisp/paren.el b/lisp/paren.el
index 7ee4e9ae682..f2756db6cd9 100644
--- a/lisp/paren.el
+++ b/lisp/paren.el
@@ -161,7 +161,9 @@ show-paren--delete-overlays
  ;;;###autoload
  (define-minor-mode show-paren-local-mode
    "Toggle `show-paren-mode' only in this buffer."
-  :variable ( show-paren-mode .
+  :variable ( (and show-paren-mode
+                   (buffer-match-p show-paren-predicate (current-buffer)))
+              .
                (lambda (val) (setq-local show-paren-mode val)))
    (cond
     ((eq show-paren-mode (default-value 'show-paren-mode))